#include "program.h"
#include "yaccmisc.h"
#include <stdio.h>

extern int yyparse ();
extern FILE *yyin;

Program *AlluvionProgram;

int main (int argc, char *argv[])
{
  if (argc != 3)
  {
    cerr << "usage: alluvion prog.alv function-call\n";
    exit (1);
  }

  AlluvionProgram = new Program ();
  AlluvionProgram->CreateBuiltInFunctions ();

  yyin = fopen (argv[1], "r");
  if (yyin == 0)
  {
    cerr << "ERROR: could not open program file \"" << argv[1] << "\"\n";
    exit (1);
  }
  int ret = yyparse ();
  if (ret) exit (1);
  AlluvionProgram->Bind ();
  //AlluvionProgram->Print ();
  AlluvionProgram->Run (argv[2]);
  delete AlluvionProgram;
}
