#ifndef ARGUMENTVECTOR_H
#define ARGUMENTVECTOR_H

#include "argumentexpression.h"
#include <vector>
#include <iostream>
#include "yyltype.h"

using namespace std;

class ArgumentVector
{
public:
  ArgumentVector () {};
  ArgumentVector (ArgumentExpression *Arg) { Args.push_back (Arg); }

  ~ArgumentVector ()
  { for (unsigned i = 0; i < Args.size (); i ++) delete Args[i]; }

  void AddArgument (ArgumentExpression *Arg) { Args.push_back (Arg); }

  ArgumentExpression *GetArgument (unsigned Index) { return Args[Index]; }
  unsigned GetArgumentCount () { return Args.size (); }

  void Print (ostream &s = cout) const
  {
    if (Args.size () == 1)
      Args[0]->Print (s);
    else
    {
      s << '(';
      for (unsigned i = 0; i < Args.size (); i ++)
      {
        if (i > 0) s << ", ";
	Args[i]->Print (s);
      }
      s << ')';
    }
  }

  void Bind (Function &Fun, AlluvionType RequiredType, BindMode BM)
  {
    for (unsigned i = 0; i < Args.size (); i ++)
      Args[i]->Bind (Fun, RequiredType, BM);
  }

  void SetPrimitiveBinding (AlluvionType ArgType)
  {
    for (unsigned i = 0; i < Args.size (); i ++)
      Args[i]->SetBinding (i, ArgType);
  }

  void SetLocation (YYLTYPE &pLoc) { Loc = pLoc; }
  YYLTYPE &GetLocation () { return Loc; }

  void PrintState (Instance &I)
  {
    for (unsigned i = 0; i < Args.size (); i ++)
      Args[i]->PrintState (I);
  }

private:
  vector<ArgumentExpression *> Args;
  YYLTYPE Loc;
};

#endif
