#include "assignment.h"
#include "instance.h"
#include <typeinfo>

void Assignment::Evaluate (Instance &Inst)
{
  try 
  {
    if (typeid (*Expr) != typeid (VectorExpression))
    {
      Inst.InitArgs (Args);
      Expr->Evaluate (Inst, Inst);
    }
    else // buffering to enable (a,b)=(b,a) type assignments
    {
      Inst.InitBufferMode ();
      Expr->Evaluate (Inst, Inst);
      Inst.FlushBuffer (Args);
    }
  }
  catch (TooManyArguments)
  {
    cerr << "ERROR at " << GetLocation ()
         << " in function \"" << Inst.GetFunction ()->GetName ()
         << "\": expression returns too many arguments in assignment\n";
    exit (1);
  }
  if (!Inst.AtEnd ())
  {
    cerr << "ERROR at " << GetLocation ()
         << " in function \"" << Inst.GetFunction ()->GetName ()
         << "\": expression returns too few arguments in assignment\n";
    exit (1);
  }
}
