#ifndef ASSIGNMENT_H
#define ASSIGNMENT_H

#include "statement.h"
#include "argumentvector.h"
#include "expression.h"
#include "yaccmisc.h"
#include <iostream>

using namespace std;

class Assignment : public Statement
{
public:
  Assignment (ArgumentVector *pArgs, Expression *pExpr, YYLTYPE &pLoc)
  : Statement (pLoc)
  { Args = pArgs;  Expr = pExpr; }

  ~Assignment ()
  { delete Args;
    delete Expr;
  }

  Expression *GetExpression () { return Expr; }
  ArgumentVector *GetArguments () { return Args; }

  void Bind (Function &Fun)
  {
    AlluvionType AT = Expr->Bind (Fun);
    Args->Bind (Fun, AT, BM_MAY_EXIST);
  }

  void Evaluate (Instance &Inst);

  void Print ()
  {
    cout << "  ";
    Args->Print ();
    cout << " = ";
    Expr->Print ();
    cout << ";\n";
  }

private:
  ArgumentVector *Args;
  Expression     *Expr;
};

#endif
