// -*-C++-*-

#ifndef BIVECTOR_H
#define BIVECTOR_H

#include <iostream>
#include <vector>

template <class Val>
class BiVector
{
public:
  BiVector () {}

  Val &operator[] (int Index)
  {
    if (Index >= 0)
    {
      if (Index >= PosVal.size ())
        PosVal.resize (Index + 1);
      return PosVal[Index];
    }
    else
    {
      Index = 1 - Index;
      if (Index >= NegVal.size ())
        NegVal.resize (Index + 1);
      return NegVal[Index];
    }
  }

  void Print ()
  {
    for (int i = NegVal.size () - 1; i >= 0; i --)
      if (NegVal[i].GetState () != ValueNotYet)
        cout << '[' << 1 - i << "] " << NegVal[i];
    for (unsigned i = 0; i < PosVal.size (); i ++)
      if (PosVal[i].GetState () != ValueNotYet)
        cout << '[' << i << "] " << PosVal[i];
  }

private:
  vector<Val> PosVal;
  vector<Val> NegVal;
};

#endif
