#ifndef BOOLEAN_H
#define BOOLEAN_H

#include "yyltype.h"

#ifndef FUNCTION_DEFINED
class Function;
#endif

#ifndef PROGRAM_DEFINED
class Program;
#endif

#ifndef INSTANCE_DEFINED
class Instance;
#endif

class Boolean
{
public:
  Boolean (YYLTYPE &pLoc)
  {
    Loc = pLoc;
  }

  virtual ~Boolean () {}

  virtual void Bind (Function &Fun) = 0;

  virtual bool Evaluate (Instance &In) = 0;

  void SetLocation (YYLTYPE &pLoc) { Loc = pLoc; }
  YYLTYPE &GetLocation () { return Loc; }

private:
  YYLTYPE Loc;
};

#endif
