#include "expression.h"
#include "vectorexpression.h"

class CallExpression : public Expression
{
public:
  CallExpression (char *pName, Expression *pParameters, YYLTYPE &Loc)
  : Expression (Loc)
  {
    Name = pName;
    Parameters = pParameters;
    ControlParameters = 0;
  }

  CallExpression ( char *pName, Expression *pParameters
                 , Expression *pControlParameters, YYLTYPE &Loc
                 )
  : Expression (Loc)
  {
    Name = pName;
    Parameters = pParameters;
    ControlParameters = pControlParameters;
  }

  ~CallExpression ()
  { delete Parameters;
    delete ControlParameters;
  }

  AlluvionType Bind (Function &Fun);

  void Evaluate (Instance &In, Instance &Out);
  int Evaluate (Instance &In) { return 0; }

  void Print (ostream &s) const;

private:
  char *Name;
  Expression *Parameters;
  Expression *ControlParameters;
  Function *CalledFun;
};
