// -*-C++-*-

#include "statement.h"
#include "rangeexpression.h"
#include "sequence.h"

class ForStatement : public Statement
{
public:
  ForStatement (char *pVarName, RangeExpression *pRng, Sequence *pSeq, YYLTYPE &pLoc)
  : Statement (pLoc)
  {
    VarName = pVarName;
    Rng = pRng;
    Seq = pSeq;
  }

  ~ForStatement ()
  { delete Rng;
    delete Seq;
  }

  void Bind (Function &Fun);

  void Evaluate (Instance &Inst);

  void Print ();

private:
  char *VarName;
  unsigned BindVar;
  RangeExpression *Rng;
  Sequence *Seq;
};
