#include "expression.h"
#include <iostream>
#include "instance.h"

class NumberExpression : public Expression
{
public:
  NumberExpression (int pNumber, YYLTYPE &pLoc)
  : Expression (pLoc)
  { Number = pNumber; }

  int GetNumber () { return Number; }

  void Negate () { Number = - Number; }

  void Print (ostream &s) const { s << Number; }

  AlluvionType Bind (Function &Fun) { return AT_CONTROLVAR; }

  void Evaluate (Instance &In, Instance &Out)
  {
    Out.AccessControlValue () = Number;
  }

  int Evaluate (Instance &In) { return Number; }

private:
  int Number;
};
