#include "statement.h"

class PrintStatement : public Statement
{
public:
  PrintStatement (ArgumentVector *pArgs, YYLTYPE &Loc)
  : Statement (Loc)
  { Args = pArgs; }

  ~PrintStatement ()
  { delete Args; }

  void Bind (Function &Fun)
  { Args->Bind (Fun, AT_NO_TYPE, BM_MUST_EXIST); }

  void Evaluate (Instance &Inst)
  { Args->PrintState (Inst); }

  void Print () {}
  
private:
  ArgumentVector *Args;
};
