//-*-C++-*-

#ifndef PROGRAM_H
#define PROGRAM_H

#include "function.h"
#include <vector>

using namespace std;

class Program
{
public:
  Program ()
  { TrueConnects = 0;
    TrueValue.Write (TrueConnects);
    TrueValue.SetState (ValueTrue);
    FalseConnects = 0;
    FalseValue.Write (FalseConnects);
    FalseValue.SetState (ValueFalse);
  }

  ~Program ()
  { for (unsigned i = 0; i < Funs.size (); i ++) delete Funs[i]; }

  void AddFunction (Function *Fun) { Funs.push_back (Fun); }
  unsigned GetFunctionCount () { return Funs.size (); }
  Function *GetFunction (unsigned i) { return Funs[i]; }

  void CreateBuiltInFunctions ();

  void Bind ()
  {
    for (unsigned i = 0; i < Funs.size (); i ++)
      Funs[i]->Bind (this);
  }

  void Run (char *Arg);

  void Print ()
  {
    for (unsigned i = 0; i < Funs.size (); i ++)
    {
      if (i > 0) cout << endl;
      Funs[i]->Print ();
    }
  }

  void Report ()
  {
    cout << "\nStatistics:\n";
    for (unsigned i = 0; i < Funs.size (); i ++)
      Funs[i]->Report ();
    if (TrueConnects)
      cout << "  " << TrueConnects << " inputs connected to 1\n";
    if (FalseConnects)
      cout << "  " << FalseConnects << " inputs connected to 0\n";
  }

  Value &GetTrueValue () { return TrueValue; }
  Value &GetFalseValue () { return FalseValue; }

private:
  vector<Function *> Funs;
  unsigned TrueConnects;
  unsigned FalseConnects;
  Value TrueValue;
  Value FalseValue;
};

#define PROGRAM_DEFINED

#endif
