#ifndef RANGE_H
#define RANGE_H

#include <iostream>

using namespace std;

class Range
{
public:
  Range () {}

  Range (int pBegin, int pEnd, int pStep)
  { Begin = pBegin;
    End = pEnd;
    Step = pStep;
  }

  Range (int pBegin, int pEnd)
  { Begin = pBegin;
    End = pEnd;
    Step = 1;
  }

  Range (int pBegin)
  { Begin = pBegin;
    End = pBegin;
    Step = 1;
  }

  //Range (Range const &Rng)
  //{ Begin = Rng.GetBegin ();
  //  End = Rng.GetEnd ();
  //  Step = Rng.GetStep ();
  //}

  int GetBegin () const { return Begin; }
  int GetEnd ()   const { return End; }
  int GetStep ()  const { return Step; }

  void SetBegin (int pBegin) { Begin = pBegin; }
  void SetEnd (int pEnd)     { End = pEnd; }
  void SetStep (int pStep)   { Step = pStep; }

  void Print (ostream &s = cout)
  { s << '[' << Begin;
    if (End != Begin)
    { s << ',' << End;
      if (Step != 1)
        s << ',' << Step;
    }
    s << ']';
  }

private:
  int Begin;
  int End;
  int Step;
};

inline ostream &operator<< (ostream &s, Range &r)
{ r.Print (s); return s; }

#endif
