#include "rangeexpression.h"
#include "instance.h"

Range RangeExpression::EvaluateRange (Instance &In)
{
  int Begin = BeginExpr->Evaluate (In);
  if (!EndExpr) return Range (Begin);
  int End = EndExpr->Evaluate (In);
  if (!StepExpr) return Range (Begin, End);
  int Step = StepExpr->Evaluate (In);
  if (Step == 0)
  {
    cerr << "ERROR at " << StepExpr->GetLocation ()
         << " in function \"" << In.GetFunction ()->GetName ()
         << "\": range step is 0\n";
    exit (1);
  }
  return Range (Begin, End, Step);

  /* empty ranges are allowed !!!
  if (pStep > 0 && pEnd < pBegin || pStep < 0 && pEnd > pBegin)
  {
    cerr << "ERROR at " << GetLocation ()
         << " in function \"" << In.GetFunction ()->GetName ()
         << "\": range [" << pBegin << ',' << pEnd << ',' << pStep
         << "] is empty\n";
    exit (1);
  }
  */
}

void RangeExpression::Print (ostream &s) const
{
  if (BeginExpr)
  {
    BeginExpr->Print (s);
    if (EndExpr)
    {
      s << ':' << *EndExpr;
      if (StepExpr)
      {
        s << ':' << *StepExpr;
      }
    }
  }
}
