//-*-C++-*-

#ifndef RANGEEXPRESSION_H
#define RANGEEXPRESSION_H

#include "expression.h"
#include "range.h"
#include <iostream>

class RangeExpression : public Expression
{
public:
  RangeExpression (Expression *pBeginExpr, Expression *pEndExpr = 0, Expression *pStepExpr = 0)
  {
    BeginExpr = pBeginExpr;
    EndExpr   = pEndExpr;
    StepExpr  = pStepExpr;
  }

  ~RangeExpression ()
  { delete BeginExpr;
    delete EndExpr;
    delete StepExpr;
  }

  AlluvionType Bind (Function &Fun)
  {
    BeginExpr->BindAndCheck (Fun, AT_CONTROLVAR);
    if (EndExpr) EndExpr->BindAndCheck (Fun, AT_CONTROLVAR);
    if (StepExpr) StepExpr->BindAndCheck (Fun, AT_CONTROLVAR);
    return AT_CONTROLVAR;
  }

  void Evaluate (Instance &In, Instance &Out) {}
  int Evaluate (Instance &In) { return 0; }

  Range EvaluateRange (Instance &In);

  void Print (ostream &s = cout) const;

private:
  Expression *BeginExpr;
  Expression *EndExpr;
  Expression *StepExpr;
};

#endif
