#ifndef RANGEITERATOR_H
#define RANGEITERATOR_H

#include "range.h"

class RangeIterator
{
public:
  RangeIterator () {}

  RangeIterator (Range pRng)
  : Rng (pRng)
  { Index = Rng.GetEnd (); }

  void operator++ (int)
  { Index -= Rng.GetStep (); }

  bool AtEnd ()
  { return (  Rng.GetStep () > 0 && Index < Rng.GetBegin ()
           || Rng.GetStep () < 0 && Index > Rng.GetBegin ()
           );
  }

  int operator* () { return Index; }

private:
  Range Rng;
  int Index;
};

#endif
