#ifndef STATEMENT_H
#define STATEMENT_H

#include "yyltype.h"

using namespace std;

#ifndef FUNCTION_DEFINED
class Function;
#endif

#ifndef PROGRAM_DEFINED
class Program;
#endif

#ifndef INSTANCE_DEFINED
class Instance;
#endif

class Statement
{
public:
  Statement (YYLTYPE &pLoc)
  { Loc = pLoc; }

  virtual ~Statement () {};

  virtual void Bind (Function &Fun) = 0;

  virtual void Evaluate (Instance &Inst) = 0;

  virtual void Print () = 0;

  void SetLocation (YYLTYPE &pLoc) { Loc = pLoc; }
  YYLTYPE &GetLocation () { return Loc; }

private:
  YYLTYPE Loc;
};

#endif
