#include "sequence.h"
#include "boolean.h"

class WhileStatement : public Statement
{
public:
  WhileStatement (Boolean *pBool, Sequence *pSeq, YYLTYPE &pLoc)
  : Statement (pLoc)
  {
    Bool = pBool;
    Seq = pSeq;
  }

  ~WhileStatement ()
  { delete Bool;
    delete Seq;
  }

  void Bind (Function &Fun)
  {
    Bool->Bind (Fun);
    Seq->Bind (Fun);
  }

  void Evaluate (Instance &Inst)
  {
    while (Bool->Evaluate (Inst))
      Seq->Evaluate (Inst);
  }

  void Print () {}

private:
  Boolean *Bool;
  Sequence *Seq;
};
